import { Type } from './metadata/type';
import { Metadata } from './metadata/metadata';
import { Condition } from './interfaces/condition';
import { OrderBy } from './interfaces/orderby';
import { ClientOptions, Client } from './client';
import { WhereCondition } from './interfaces/where-condition';
export declare class Redisk {
    private readonly metadata;
    private readonly client;
    constructor(metadata: Metadata, client: Client);
    static init(options: ClientOptions): Redisk;
    close(): Promise<void>;
    getClient(): Client;
    save<T>(entity: T): Promise<void>;
    count<T>(entityType: Type<T>): Promise<number>;
    list<T>(entityType: Type<T>, where?: {
        conditions: WhereCondition[];
        type: 'AND' | 'OR';
    }, limit?: number, offset?: number, orderBy?: OrderBy): Promise<T[]>;
    search<T>(entityType: Type<T>, condition: Condition, limit: number): Promise<T[]>;
    searchIds<T>(entityType: Type<T>, condition: Condition, limit: number): Promise<string[]>;
    listIds<T>(entityType: Type<T>, where?: {
        conditions: WhereCondition[];
        type: 'AND' | 'OR';
    }, limit?: number, offset?: number, orderBy?: OrderBy): Promise<string[]>;
    delete<T>(entityType: Type<T>, id: string): Promise<void>;
    getOne<T>(entityType: Type<T>, value: any, key?: string): Promise<T>;
    private convertPropertyTypeToPrimitive;
    private convertStringToPropertyType;
    private dropUniqueKeys;
    private dropIndexes;
    private dropIndex;
    private dropSearchables;
    private getIndexNumberKeyName;
    private getIndexKeyName;
    private getIndexPrefix;
    private getListKeyName;
    private getUniqueKeyName;
    private getSearchableKeyName;
    private getSearchableValuePrefix;
}
